#!/usr/bin/python
# Copyright 2016 CERN and GSI
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os
import shutil

def fileExists(fileName):
    return os.path.isfile(fileName)

def write(string, filePath):
    with open(filePath, 'w') as f:
        f.write(string)

def backupFile(fileName):
    src = fileName
    dst = fileName + ".backup"
    print("Original file backed up by adding '.backup'")
    shutil.copyfile(src, dst)
    
def getExtension(fileName):
    '''Returns the file extension, dot included'''
    return fileName[fileName.rfind('.'):]

def getProjectDir(fesaDocument):
    absPath = os.path.abspath(fesaDocument)
    return os.path.dirname(os.path.dirname(absPath))
