// Copyright 2016 CERN and GSI
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef _RECV_PLC_ACTION_H_
#define _RECV_PLC_ACTION_H_

#include <silecs-communication/interface/core/PLCAction.h>

namespace Silecs
{
	class Action;
	class Block;
	class Context;

	/*!
	 * \class PLCRecvBlockMode
	 * \brief Concrete action responsible to get a data block from the PLC (Block mode configuration)
	 */
	class PLCRecvBlockMode : public PLCAction
	{

	public:
		PLCRecvBlockMode(Block* block);
 		virtual ~PLCRecvBlockMode();

        /*!
         * \fn execute
         * Connect the PLC if necessary and Get data-block from its memory.
         * Overwrite the abstract method
         * \return 0 if no error occurred. else return a error status from low level library
         */
		int execute(Context* pContext);

	private:

	};

	/*!
	 * \class PLCRecvDeviceMode
	 * \brief Concrete action responsible to get a data block from the PLC (Device mode configuration)
	 */
	class PLCRecvDeviceMode : public PLCAction
	{

	public:
		PLCRecvDeviceMode(Block* block);
 		virtual ~PLCRecvDeviceMode();

        /*!
         * \fn execute
         * Connect the PLC if necessary and Get data-block from its memory.
         * Overwrite the abstract method
         * \return 0 if no error occurred. else return a error status from low level library
         */
		int execute(Context* pContext);

	private:

	};

} // namespace

#endif // _RECV_PLC_ACTION_H_

