// Copyright 2016 CERN and GSI
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SILECS_DIAG_CONSTANTS_H
#define SILECS_DIAG_CONSTANTS_H
#include <string>

/*
 * Different string type
 */
const std::string CLUSTER_TYPE       = "CLUSTER";
const std::string PLC_TYPE           = "PLC";
const std::string DEVICE_TYPE        = "DEVICE";
const std::string REGISTER_TYPE      = "REGISTER";

/*
* Different project path
*/

// SILECS HEADER
const std::string HEADER_NAME            = "SilecsHeader";
const std::string HEADER_VERSION         = "1.0.0";
const std::string HEADER_DEVICE          = "0";
const std::string HEADER_BLOCK           = "hdrBlk";
const std::string HEADER_RELEASE_REG     = "_version";
const std::string HEADER_OWNER_REG       = "_user";
const std::string HEADER_DATE_REG        = "_date";
const std::string HEADER_CHECKSUM_REG    = "_checksum";

//splash screen time (in seconds)
const unsigned long SPLASH_SCREEN_TIME  = 1;
const int NUMBER_PASSWORD_ATTEMPTS      = 3;

// max buffer lenght for PLC name
const int MAX_BUFFER = 1024;

#endif // SILECS_DIAG_CONSTANTS_H
