// Copyright 2016 CERN and GSI
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SILECS_DIAG_DISPLAYARRAYDIALOG_H
#define SILECS_DIAG_DISPLAYARRAYDIALOG_H

#include <QDialog>

namespace Ui {
    class DisplayArrayDialog;
}

class DisplayArrayDialog : public QDialog
{
    Q_OBJECT

public:
    explicit DisplayArrayDialog(QWidget *parent = 0);
    ~DisplayArrayDialog();

    void setDataVector(std::vector<QString> dataVector, bool editable, unsigned long dim2);

    std::vector<QString> getDataVector();

private slots:
    void on_buttonBox_accepted();

private:
    Ui::DisplayArrayDialog *ui;

    std::vector<QString> dataVector;

};

#endif // SILECS_DIAG_DISPLAYARRAYDIALOG_H
